#---------------------------------------------------------#
# MAPLEV MODULE                                           #
#	Rentrer les paramtres dans artiData.mpl 	  #
#	avant d'executer ce fichier.			  #
#---------------------------------------------------------#

with(linalg):
readlib(C):

print(`Lecture des donnes numriques dans artiData.mpl`);
read cat(rep,`artiData.mpl`);
printf(`OK\n`);

#---------------------------------------------------------#
# Formules de base                  			  #
#---------------------------------------------------------#

#---------------------------------------------------------#
# Chevilles	                  			  #
#---------------------------------------------------------#
p3:=Pas3/(2*Pi): 
C2:=cos(Q2): 
S2:=sin(Q2): 
C3:=cos(Q3): 
S3:=sin(Q3): 
E1:=bp*C2: 
E2:=bp*S2: 
E3:=dp*C2: 
E4:=dp*S2: 
a2:=E2+E3: 
b2:=E3-E2: 
c2:=E1+E4: 
d2:=E1-E4: 
E5:=d2*C3: 
E6:=d2*S3: 
E7:=c2*C3: 
E8:=c2*S3: 
f2:=h3-a2: 
g2:=b2-h3: 
a3:=cp*C3: 
b3:=cp*S3: 
a23:=e3-E6-a3: 
b23:=e3-E8-a3: 
c23:=sqrt(l3^2-a23^2-f2^2): 
d23:=sqrt(l3^2-b23^2-g2^2): 
x32:=a2*C3-(a2*a23*S3-f2*d2)/c23: 
x33:=E6+a3-(a23*(b3-E5))/c23: 
x332:=-b2*C3+(b2*b23*S3+c2*g2)/d23: 
x333:=E8+a3+(b23*(E7-b3))/d23: 
A23:=(x32*x333-x33*x332): 
B23:=p*(CPL2*x333-CPL3*x332): 
C23:=p*(x32*CPL3-x33*CPL2): 
x3:=-E5+b3+c23: 
x33:=-E7+b3+d23: 
tr2:=x->subs({Q2=Pi/180*q2},x): 
tr3:=x->subs({Q3=Pi/180*(q3+GAM3)},x):

x3_0:=evalf(subs({q3=q3_init,q2=q2_init},tr2(tr3(x3)))): 
x33_0:=evalf(subs({q3=q3_init,q2=q2_init},tr2(tr3(x33)))):
theta3:=(x3-x3_0)/p3: 
theta33:=(x33-x33_0)/p3: 
som3:=theta3+theta33: 
diff3:=theta3-theta33: 

som3_0:=evalf(subs({q3=q3_init,q2=q2_init},tr2(tr3(som3)))): 
diff3_0:=evalf(subs({q3=q3_init,q2=q2_init},tr2(tr3(diff3)))):
som3_max:=evalf(subs({q3=q3_max,q2=q2_init},tr2(tr3(som3)))): 
som3_min:=evalf(subs({q3=q3_min,q2=q2_max},tr2(tr3(som3)))): 
diff3_max:=evalf(subs({q3=q3_init,q2=q2_max},tr2(tr3(diff3)))): 
diff3_min:=evalf(subs({q3=q3_init,q2=q2_min},tr2(tr3(diff3)))): 
delta_som3:=som3_max-som3_min: delta_diff3:=diff3_max-diff3_min: 

# Les fonctions q2=f2(s,d) et q3=f3(s,d) ne sont pas connues explicitement d'o l'utilisation du fsolve #

q2_d:=(som3_d,diff3_d)->Pi/180*subs(fsolve({tr2(tr3(som3))=som3_d,tr2(tr3(diff3))=diff3_d},{q2,q3},{q2=q2_min-20..q2_max+20,q3=q3_min-20..q3_max+20}),q2):
q3_d:=(som3_d,diff3_d)->Pi/180*subs(fsolve({tr2(tr3(som3))=som3_d,tr2(tr3(diff3))=diff3_d},{q2,q3},{q2=q2_min-20..q2_max+20,q3=q3_min-20..q3_max+20}),q3):

#---------------------------------------------------------#
# Genou		                  			  #
#---------------------------------------------------------#
p4:=Pas4*Red4/(2*Pi):
S4:=sin(Q4): 
C4:=cos(Q4): 
a4:=e4-R4*S4: 
b4:=sqrt(l4^2-a4^2): 
k4:=a4*C4/b4-S4: 
x4:= R4*C4+b4: 
tr4:=x->subs({Q4=Pi/180*(q4+GAM4-PHI3)},x):

x4_0:=evalf(subs({q4=q4_init},tr4(x4))): 
theta4:=(x4-x4_0)/p4:

x4_max:=evalf(subs({q4=q4_min},tr4(x4))): 
x4_min:=evalf(subs({q4=q4_max},tr4(x4))): 
delta_x4:=x4_max-x4_min: 
theta4_0:=evalf(subs({q4=q4_init},tr4(theta4))): 
theta4_max:=evalf(subs({q4=q4_min},tr4(theta4))): 
theta4_min:=evalf(subs({q4=q4_max},tr4(theta4))): 
delta_theta4:=theta4_max-theta4_min: 

x4_d:=theta4_d*p4+x4_0: 
Kx4:=(x4_d^2+R4^2+e4^2-l4^2)/(2*R4): 
q4_2:=arccos((x4_d*Kx4-e4*sqrt(x4_d^2+e4^2-Kx4^2))/(x4_d^2+e4^2))+Pi/180*(PHI3-GAM4):  

#---------------------------------------------------------#
# Hanche	                  			  #
#---------------------------------------------------------#
p5:=Pas5*Red5/(2*Pi): 
S5:=sin(Q5): 
C5:=cos(Q5): 
a5:=R5*S5-e5: 
b5:=sqrt(l5^2-a5^2): 
k5:=S5-a5*C5/b5: 
x5:= -R5*C5+b5: 
tr5:=x->subs({Q5=Pi/180*(q5+PHI5-GAM4)},x):

x5_0:=evalf(subs({q5=q5_init},tr5(x5))): theta5:=(x5-x5_0)/p5: 

x5_min:=evalf(subs({q5=q5_min},tr5(x5))): 
x5_max:=evalf(subs({q5=q5_max},tr5(x5))): 
delta_x5:=x5_max-x5_min:  
theta5_0:=evalf(subs({q5=q5_init},tr5(theta5))): 
theta5_max:=evalf(subs({q5=q5_min},tr5(theta5))): 
theta5_min:=evalf(subs({q5=q5_max},tr5(theta5))): 
delta_theta5:=theta5_max-theta5_min:

x5_d:=theta5_d*p5+x5_0: 
Kx5:=(x5_d^2+R5^2+e5^2-l5^2)/(2*R5): 
q5_1:=arccos((-x5_d*Kx5+e5*sqrt(x5_d^2+e5^2-Kx5^2))/(x5_d^2+e5^2))-Pi/180*(PHI5-GAM4):

#---------------------------------------------------------#
# Calculs d'erreur                 			  #
#---------------------------------------------------------#
err_top := evalf(2*Pi/NbrTop)+bruit_top:


#---------------------------------------------------------#
# Chevilles	                  			  #
#---------------------------------------------------------#
invJac:=jacobian(vector([som3,diff3]),[Q2,Q3]): Jac:=inverse(invJac):

q2_Ks:=evalf(subs({q2=q2_max,q3=q3_max},tr2(tr3(Jac[1,1])))):
q2_Kd:=evalf(subs({q2=q2_min,q3=q3_min},tr2(tr3(Jac[1,2])))):
q3_Ks:=evalf(subs({q2=0,q3=q3_min},tr2(tr3(Jac[2,1])))):
q3_Kd:=evalf(subs({q2=q2_max,q3=q3_min},tr2(tr3(Jac[2,2])))):

q3_err_top:=2*err_top*(q3_Ks+q3_Kd): 
q2_err_top:=2*err_top*(q2_Ks+q2_Kd):

ddq2_dds:=diff(Jac[1,1],Q2)*Jac[1,1]+diff(Jac[1,1],Q3)*Jac[2,1]:
ddq2_ddd:=diff(Jac[1,2],Q2)*Jac[1,2]+diff(Jac[1,2],Q3)*Jac[2,2]:
ddq3_dds:=diff(Jac[2,1],Q3)*Jac[2,1]+diff(Jac[2,1],Q2)*Jac[1,1]:
ddq3_ddd:=diff(Jac[2,2],Q3)*Jac[2,2]+diff(Jac[2,2],Q2)*Jac[1,2]:

q2_KKs:=evalf(subs({q2=q2_max,q3=q3_max},tr2(tr3(ddq2_dds)))): 
q2_KKd:=evalf(subs({q2=q2_max,q3=q3_max},tr2(tr3(ddq2_ddd)))): 
q3_KKs:=evalf(subs({q2=q2_max,q3=q3_max},tr2(tr3(ddq3_dds)))): 
q3_KKd:=evalf(subs({q2=q2_min,q3=q3_min},tr2(tr3(ddq3_ddd)))):

#---------------------------------------------------------#
# Genou		                  			  #
#---------------------------------------------------------#

dq4_2:= diff(q4_2,theta4_d): 
q4_K:=abs(evalf(subs(theta4_d=theta4_max,dq4_2))): 
q4_err_top:=err_top*q4_K:

ddq4_2:= diff(q4_2,theta4_d,theta4_d): 
q4_KK:=abs(evalf(subs(theta4_d=theta4_max,ddq4_2))):

#---------------------------------------------------------#
# Hanche	                  			  #
#---------------------------------------------------------#

dq5_1:= diff(q5_1,theta5_d): 
q5_K:=abs(evalf(subs(theta5_d=theta5_min,dq5_1))): 
q5_err_top:=err_top*q5_K:

ddq5_1:= diff(q5_1,theta5_d,theta5_d):
q5_KK:=abs(evalf(subs(theta5_d=theta5_min,ddq5_1))):

#---------------------------------------------------------#
# Construction du tableau de valeurs  			  #
#---------------------------------------------------------#

#---------------------------------------------------------#
# Chevilles	                  			  #
#---------------------------------------------------------#

q2_approx:=10^(-(Digits-1)): 
q2_err_min:=evalf(180/Pi*(q2_approx+q2_err_top)):

x:=evalf(Pi/180*q2_err_toleree-q2_approx-q2_err_top): 
q2_pas_som3:=evalf(sqrt(2*x/q2_KKs)): 
q2_pas_diff3:=evalf(sqrt(2*x/q2_KKd)):
q2_nbr_som3:=round(delta_som3/q2_pas_som3)+1: 
q2_nbr_diff3:=round(delta_diff3/2/q2_pas_diff3)+1: 
q2_nbr_valeurs:=q2_nbr_som3*q2_nbr_diff3: 

q3_approx:=10^(-(Digits-1)): 
q3_err_min:=evalf(180/Pi*(q3_approx+q3_err_top)):

x:=evalf(Pi/180*q3_err_toleree-q3_approx-q3_err_top):
q3_pas_som3:=evalf(sqrt(2*x/q3_KKs)): 
q3_pas_diff3:=evalf(sqrt(2*x/q3_KKd)):
q3_nbr_som3:=round(delta_som3/q3_pas_som3)+1: 
q3_nbr_diff3:=round(delta_diff3/2/q3_pas_diff3)+1: 
q3_nbr_valeurs:=q3_nbr_som3*q3_nbr_diff3:

printf(`Cheville : (symtrie par rapport  diff3)\n`);
printf(`Frontale :`);
array([[`erreur tolre`,`Nbr de valeurs`],[evalf(q2_err_toleree),q2_nbr_valeurs]]); 
printf(`Sagittale :`);
array([[`erreur tolre`,`Nbr de valeurs`],[evalf(q3_err_toleree),q3_nbr_valeurs]]);


printf(`Calcul des tableaux de valeurs\n`);

printf(`Frontale\n`);
tab_q2:=vector([seq(seq(evalf(q2_d(som3_min+i*q2_pas_som3,j*q2_pas_diff3)),j=0..q2_nbr_diff3-1),i=0..q2_nbr_som3-1)]):

printf(`Sagittale\n`);
tab_q3:=vector([seq(seq(evalf(q3_d(som3_min+i*q3_pas_som3,j*q3_pas_diff3)),j=0..q3_nbr_diff3-1),i=0..q3_nbr_som3-1)]):

#---------------------------------------------------------#
# Genou		                  			  #
#---------------------------------------------------------#

q4_approx:=10^(-(Digits-1)):  
q4_err_min:=evalf(180/Pi*(q4_approx+q4_err_top)):

q4_pas_theta4:=evalf(sqrt(2*(Pi/180*(q4_err_toleree)-q4_approx-q4_err_top)/q4_KK)): 
q4_nbr_valeurs:=round(delta_theta4/q4_pas_theta4)+1:

printf(`Genou :`);
array([[`erreur tolre`,`Nbr de valeurs`],[evalf(q4_err_toleree),q4_nbr_valeurs]]);

printf(`Calcul du tableau\n`); 
tab_q4:=vector([seq(q4_approx*evalf(round(1/q4_approx*subs(theta4_d=theta4_min+i*q4_pas_theta4,q4_2))),i=0..q4_nbr_valeurs-1)]):

#---------------------------------------------------------#
# Hanche	                  			  #
#---------------------------------------------------------#
 
q5_approx:=10^(-(Digits-1)):  
q5_err_min:=evalf(180/Pi*(q5_approx+q5_err_top)):

q5_pas_theta5:=evalf(sqrt(2*(Pi/180*(q5_err_toleree)-q5_approx-q5_err_top)/q5_KK)): 
q5_nbr_valeurs:=round(delta_theta5/q5_pas_theta5)+1: 

printf(`Hanche :`);
array([[`erreur tolre`,`Nbr de valeurs`],[evalf(q5_err_toleree),q5_nbr_valeurs]]);
printf(`Calcul du tableau\n`);
tab_q5:=vector([seq(q5_approx*evalf(round(1/q5_approx*subs(theta5_d=theta5_min+i*q5_pas_theta5,q5_1))),i=0..q5_nbr_valeurs-1)]):

#---------------------------------------------------------#
# Ecriture du tableau de valeurs dans un fichier	  #
#---------------------------------------------------------#

printf(`Cration du fichier des tableaux de valeurs: %s\n`,fileData);
 
writeto(fileData);
printf("double posChevSag[%d]={",q3_nbr_valeurs);
seq(tab_q3[i],i=1..q3_nbr_valeurs);
printf("};\n");
printf("double posChevFron[%d]={",q2_nbr_valeurs);
seq(tab_q2[i],i=1..q2_nbr_valeurs);
printf("};\n");
printf("double posGen[%d]={",q4_nbr_valeurs);
seq(tab_q4[i],i=1..q4_nbr_valeurs);
printf("};\n");
printf("double posHanche[%d]={",q5_nbr_valeurs);
seq(tab_q5[i],i=1..q5_nbr_valeurs);
printf("};\n");
writeto(terminal);

printf(`Cration du fichier d'affectation de donnes : %s\n`,fileC);
writeto(fileC);


printf("pos[CHEV_SAG].dim=2;\n");
printf("pos[CHEV_SAG].valMin[0]=%g;\n",som3_min);
printf("pos[CHEV_SAG].valMin[1]=%g;\n",0); # symtrie par rapport  diff3 #
printf("pos[CHEV_SAG].pas[0]=%g;\n",q3_pas_som3);
printf("pos[CHEV_SAG].pas[1]=%g;\n",q3_pas_diff3);
printf("pos[CHEV_SAG].nbrVal[0]=%g;\n",q3_nbr_som3);
printf("pos[CHEV_SAG].nbrVal[1]=%g;\n",q3_nbr_diff3);
printf("pos[CHEV_SAG].tab=posChevSag;\n");

printf("pos[CHEV_FRON].dim=2;\n");
printf("pos[CHEV_FRON].valMin[0]=%g;\n",som3_min);
printf("pos[CHEV_FRON].valMin[1]=%g;\n",0);# antisymtrie par rapport  diff3 #
printf("pos[CHEV_FRON].pas[0]=%g;\n",q2_pas_som3);
printf("pos[CHEV_FRON].pas[1]=%g;\n",q2_pas_diff3);
printf("pos[CHEV_FRON].nbrVal[0]=%g;\n",q2_nbr_som3);
printf("pos[CHEV_FRON].nbrVal[1]=%g;\n",q2_nbr_diff3);
printf("pos[CHEV_FRON].tab=posChevFron;\n");

printf("pos[GEN].dim=1;\n");
printf("pos[GEN].valMin[0]=%g;\n",theta4_min);
printf("pos[GEN].pas[0]=%g;\n",q4_pas_theta4);
printf("pos[GEN].nbrVal[0]=%g;\n",q4_nbr_valeurs);
printf("pos[GEN].tab=posGen;\n");

printf("pos[HANCHE].dim=1;\n");
printf("pos[HANCHE].valMin[0]=%g;\n",theta5_min);
printf("pos[HANCHE].pas[0]=%g;\n",q5_pas_theta5);
printf("pos[HANCHE].nbrVal[0]=%g;\n",q5_nbr_valeurs);
printf("pos[HANCHE].tab=posGen;\n");
writeto(terminal);


printf(`FIN`);


