
/* 
*** utilisation de NDARTI : *** 
Plusieurs degrs de libert peuvent se rfrer  un mme type d'articulation. Par exemple les genous droit et gauche se rfrent au tableau de valeur du GENOU. Nous choisissons une indexation des degrs de libert qui permette de retrouver facilement le type correspondant : Numro du degr de libert modulo le nombre de type d'articulation. Si on doit rajouter un degr de libert unique, il suffit d'augmenter NDARTI et d'intercaler ce DDL aprs la 1ere srie de DDL
*******************************
*/ 

/* Nom et index de chaque articulation  */
typedef enum {
  CHEV_SAG,
  CHEV_FRON,
  GEN,
  HANCHE,
} NOM_ARTI;

typedef enum {
  DRT,
  GCH
} DRT_GCH;

/* intercaler un nouveau DDL aprs  HANCHE_DRT et avant  CHEV_SAG_GCH */
typedef enum {
  CHEV_SAG_DRT,
  CHEV_FRON_DRT,
  GEN_DRT,
  HANCHE_DRT,
  CHEV_SAG_GCH,
  CHEV_FRON_GCH,
  GEN_GCH,
  HANCHE_GCH
} NOM_ARTI_TOT;

/* structures de donnes */

typedef struct paramTab { 
  short dim;
  double valMin[2]; 
  double pas[2];
  int nbrVal[2];
  double *tab;
} PARAM_TAB;

/* Constantes */
#define NDDL   8
#define NDARTI 4

/* Liste des fonctions */
/* Conversion de l'angle moteur theta_abs en angle articulaire Pa_abs */
extern void  posInit(double theta[][2], double Pa[]);
extern void  posCompute(double theta[][2], double Pa[]);
